unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,  Dialogs, ExtCtrls, Menus, ComCtrls,
  UProto, UFPuntuales, gfx_files, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Puntuales1: TMenuItem;
    Negativo1: TMenuItem;
    Suma1: TMenuItem;
    Gamma1: TMenuItem;
    Salvar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Opciones1: TMenuItem;
    Deshacer1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Negativo1Click(Sender: TObject);
    procedure Suma1Click(Sender: TObject);
    procedure Gamma1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    nom      : string;
    M1,M2    :  Mat3D;
    nx,ny    : integer;
    BM1      : TBitMap;
    bopen    : boolean;
  end;

var
  Form1: TForm1;


implementation

uses UTomaDato;


{$R *.dfm}

// create
procedure TForm1.FormCreate(Sender: TObject);
begin
  bopen :=  false;
end;


// Abrir de Archivo
procedure TForm1.Abrir1Click(Sender: TObject);
begin
  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;

    BM1 := TBitMap.Create;
    gfx_files.LoadAnyImageToBMP(BM1,nom,false,0,0);
//    BM1.LoadFromFile(nom);  // lo carga a un BitMap en Memoria

    Image1.Picture.Assign(BM1);   // manda al Image en la interfase

    nx := Image1.Width;
    ny := Image1.Height;
    M1.nc := nx;
    M1.nr := ny;

    BM2Mat(BM1,M1);  // lo copia a una matriz M[x][y][c]
    bopen := true;
  end;
end;

// Salvar Como  Archivo
procedure TForm1.Salvar1Click(Sender: TObject);
begin
  if bopen then begin
    SaveDialog1.Filter := gfx_files._SaveFilterString;
    SaveDialog1.FileName := nom;
    if SaveDialog1.Execute then begin
      nom := SaveDialog1.FileName;
      gfx_files.SaveBMPToAnyFile(BM1,nom,0,0);
//      BM1.SaveToFile(nom);
    end;

  end;
end;

// Mover el cursor
procedure TForm1.Image1MouseMove(Sender: TObject;
   Shift: TShiftState;
   X, Y: Integer);
var
  Pix   : integer;
  r,g,b : byte;
begin
   Pix := Image1.Canvas.Pixels[X,Y];
   r := Pix and $FF;
   g := (Pix SHR 8 ) and $FF;
   b := (Pix SHR 16) and $FF;

   // escribir componentes
   StatusBar1.Panels[0].Text := IntToStr(X);
   StatusBar1.Panels[1].Text := IntToStr(Y);

   StatusBar1.Panels[2].Text := IntToStr(r);
   StatusBar1.Panels[3].Text := IntToStr(g);
   StatusBar1.Panels[4].Text := IntToStr(b);

end;

// Deshacer
procedure TForm1.Deshacer1Click(Sender: TObject);
begin
  if (M2.nc+M2.nr) > 0 then begin
    Intercambio (M1,M2);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;

end;

// Canales activos
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  kan[0] := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  kan[1] := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  kan[2] := CheckBox3.Checked;
end;

// --- Filtros Puntuales -----------------------

// Negativo
procedure TForm1.Negativo1Click(Sender: TObject);
begin
  if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

  FP_Negativo(M1,M2);
  Mat2BM(M2,BM1);
  Image1.Picture.Assign(BM1);
end;

// Corrimiento constante
procedure TForm1.Suma1Click(Sender: TObject);
var
  blec  : single;
begin
  Form2.ShowModal;

  if Form2.ModalResult = mrOK then begin
    blec := Form2.b;

    if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

    FP_Suma(M1,M2,blec);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;

end;

// Gamma
procedure TForm1.Gamma1Click(Sender: TObject);
var
  blec  : single;
begin
  Form2.ShowModal;

  if Form2.ModalResult = mrOK then begin
    blec := Form2.b;

    if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

    FP_Gamma(M1,M2,blec);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;
end;

end.
